<template>
  <div id="dataPublicationProjectData">
    <!-- General Description -->
    <i18n-t
      keypath="page.dataPublicationForm.description1"
      tag="p"
      class="mb-3"
    >
      <template #email>
        <b-link :href="'mailto:' + contactEmail" target="_blank">
          {{ $t("page.dataPublicationForm.email") }}
        </b-link>
      </template>
    </i18n-t>

    <!-- Publication Service -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="services"
      :label="$t('page.dataPublicationForm.labels.serviceLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <multiselect
        id="services"
        ref="service"
        v-model="selectedService"
        :disabled="disabled || !isOwner"
        :options="publicationServices"
        :multiple="false"
        :hide-selected="false"
        :show-labels="false"
        label="displayName"
        track-by="displayName"
        :placeholder="$t('page.dataPublicationForm.service')"
        @search-change="retrievePublicationOrganizations"
      />
      <template v-if="selectedServiceText" #hint>
        {{ selectedServiceText }}
      </template>
    </CoscineFormGroup>

    <!-- Form Description -->
    <p class="mb-3">{{ $t("page.dataPublicationForm.description2") }}</p>

    <!-- Requester Name -->
    <CoscineFormGroup
      label-for="requesterName"
      :label="$t('page.dataPublicationForm.labels.requesterNameLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="requesterName"
        :model-value="user ? user.displayName : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Email -->
    <CoscineFormGroup
      label-for="email"
      :label="$t('page.dataPublicationForm.labels.emailLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="email"
        :model-value="email ? email : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Project Name -->
    <CoscineFormGroup
      label-for="projectName"
      :label="$t('page.dataPublicationForm.labels.projectNameLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="projectName"
        :model-value="project ? project.name : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Project PID-->
    <CoscineFormGroup
      label-for="pid"
      :label="$t('page.dataPublicationForm.labels.pidLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="pid"
        :model-value="project ? project.pid : ''"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Project Discipline -->
    <CoscineFormGroup
      label-for="discipline"
      :label="$t('page.dataPublicationForm.labels.disciplineLabel')"
      :is-loading="isLoading"
    >
      <multiselect
        id="discipline"
        v-model="disciplines"
        :disabled="true"
        :options="disciplines"
        :multiple="true"
        :hide-selected="false"
        :label="disciplineLabel"
        :track-by="disciplineLabel"
        :placeholder="$t('form.project.projectDiscipline')"
        :show-labels="false"
      >
        <template #singleLabel="entities">
          <div :disabled="disabled">
            {{ entities.option[disciplineLabel] }}
          </div>
        </template>
        <template #option="entities">
          <div :disabled="disabled">
            {{ entities.option[disciplineLabel] }}
          </div>
        </template>
      </multiselect>
    </CoscineFormGroup>

    <!-- Resources -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="resources"
      :label="$t('page.dataPublicationForm.labels.resourceLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <multiselect
        id="resources"
        v-model="selectedResources"
        :options="resources"
        :disabled="disabled || !isOwner || resources.length === 0"
        label="displayName"
        track-by="displayName"
        :hide-selected="false"
        :multiple="true"
        :placeholder="$t('page.dataPublicationForm.resource')"
        @change="setResources(selectedResources)"
      >
        <!--@input="setSelectedResource"-->
        <template #popover>
          {{ $t("page.dataPublicationForm.resourceLabelPopover") }}
        </template>
      </multiselect>
    </CoscineFormGroup>

    <!-- Message Field Description -->
    <p class="mb-3">{{ $t("page.dataPublicationForm.description3") }}</p>

    <!-- Message -->
    <CoscineFormGroup
      label-for="message"
      :label="$t('page.dataPublicationForm.labels.messageLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-textarea
        id="message"
        v-model="localMessage"
        :disabled="disabled || !isOwner"
        :maxlength="v$.modelValue.message.maxLength.$params.max"
        @update:modelValue="setMessage"
      />
      <template #popover>
        {{ $t("page.dataPublicationForm.messageLabelPopover") }}
      </template>
      <!-- number of characters -->
      <template #hint>
        {{ modelValue.message?.length ?? 0 }} /
        {{ v$.modelValue.message.maxLength.$params.max }}
      </template>
    </CoscineFormGroup>

    <!-- Continue Button -->

    <b-form-group class="mb-3">
      <b-button
        id="SubmitRequestBtn"
        :disabled="disabled || v$.modelValue.$invalid || !isOwner"
        variant="primary"
        class="float-right"
        @click="next"
      >
        {{ $t("buttons.next") }}
      </b-button>
    </b-form-group>
  </div>
</template>

<script lang="ts">
import { maxLength, required } from "@vuelidate/validators";
import { useVuelidate } from "@vuelidate/core";

// import the store for current module
import useProjectStore from "../../../store";
import useUserStore from "@/modules/user/store";
import useResourceStore from "@/modules/resource/store";
import useMainStore from "@/store/index";
import type { VisitedProjectDto } from "@/modules/project/types";
import type {
  DisciplineDto,
  OrganizationDto,
  PublicationRequestForCreationDto,
  ResourceDto,
  UserDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    modelValue: {
      type: Object as PropType<PublicationRequestForCreationDto>,
      required: true,
    },
    disabled: {
      default: false,
      type: Boolean,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
  },

  emits: {
    valid: (_: boolean) => true,
    next: null,
    "update:modelValue": (_: PublicationRequestForCreationDto) => true,
    "update:resourceIds": (_: string[]) => true,
    "update:message": (_: string | null) => true,
  },
  setup(props) {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();
    const userStore = useUserStore();
    const mainStore = useMainStore();
    /*
      Definition of the validation rules and initial state
      will enable proper typings in the code
    */
    const state = reactive({
      modelValue: ref(props.modelValue),
    });

    const rules = {
      modelValue: {
        publicationServiceRorId: { required },
        resourceIds: { required },
        message: { maxLength: maxLength(1000) },
      },
    };
    const v$ = useVuelidate(rules, state);
    return { projectStore, resourceStore, userStore, mainStore, v$ };
  },
  data() {
    return {
      isLoadingPublicationServices: false,
      queryTimer: 0,
      selectedService: undefined as OrganizationDto | undefined,
      selectedServiceText: "" as string,
      selectedResources: [] as ResourceDto[],
      localResourceIds: this.modelValue.resourceIds,
      localMessage: this.modelValue.message,
    };
  },
  computed: {
    disciplines(): DisciplineDto[] {
      return this.project?.disciplines ?? [];
    },
    disciplineLabel(): string {
      let locale = this.$i18n.locale;
      // Ensure that the value of locale is a valid locale, otherwie the property for disciplineLabel will be inaccurate
      if (this.$i18n.availableLocales.includes(locale) === false) {
        locale = this.$i18n.fallbackLocale.toString();
      }
      locale = locale.charAt(0).toUpperCase() + locale.slice(1);
      return `displayName${locale}`;
    },
    isOwner(): boolean | undefined {
      return this.projectStore.currentUserRoleIsOwner;
    },
    publicationServices(): OrganizationDto[] {
      return this.organizationsWithPublicationService.map((org) => ({
        displayName: org.publicationAdvisoryService?.displayName,
        uri: org.uri,
        publicationAdvisoryService: org.publicationAdvisoryService,
      }));
    },
    currentLanguage(): string {
      return this.mainStore.coscine.locale;
    },
    project(): VisitedProjectDto | null {
      return this.projectStore.currentProject;
    },
    email(): string | undefined {
      if (this.user?.emails) {
        return this.user.emails
          .map((user) => (user.email ? user.email : "")) // Extract email display name, could contain empty strings
          .filter((n) => n) // Filter out empty strings, if any
          .at(0);
      }
      return "";
    },
    organizationsWithPublicationService(): OrganizationDto[] {
      return this.projectStore?.publicationAdvisoryServices ?? [];
    },

    resources(): ResourceDto[] {
      if (this.projectStore?.currentResources) {
        return this.projectStore?.currentResources
          .map((resource) => ({
            displayName: resource.displayName,
            id: resource.id,
          })) // Extract resource display name, could contain empty strings
          .filter((n) => n); // Filter out empty strings, if any;
      }
      return [];
    },

    user(): UserDto | null | undefined {
      return this.userStore.user;
    },

    contactEmail(): string {
      return this.userStore.contactEmail;
    },
  },
  watch: {
    modelValue: {
      handler() {
        this.$emit("update:modelValue", this.modelValue);
      },
      deep: true,
    },
    selectedService() {
      this.v$.modelValue.publicationServiceRorId.$model =
        this.selectedService?.uri ?? "";

      this.selectedServiceText =
        this.selectedService?.publicationAdvisoryService?.description ?? "";
    },
    selectedResources() {
      const resourceIds = this.selectedResources
        .map((resource) => resource.id)
        .filter((n): n is string => n !== undefined);
      this.v$.modelValue.resourceIds.$model = resourceIds ?? [];

      if (resourceIds.length != 0) {
        this.$emit("valid", true);
      }
    },
    "v$.modelValue.$invalid"() {
      this.$emit("valid", !this.v$.modelValue.$invalid);
    },
    async currentLanguage(newValue, oldValue) {
      if (newValue !== oldValue) {
        await this.projectStore.retrievePublicationOrganizations(newValue);
        this.selectedService = this.publicationServices.find(
          (s) => s.uri === this.modelValue.publicationServiceRorId,
        );
        this.selectedServiceText =
          this.publicationServices[0].publicationAdvisoryService?.description ??
          "";
      }
    },
  },
  async created() {
    this.initTabContent();

    await this.fetchData();
  },
  methods: {
    /**
     * Initializes the content of the selected application profile based on the current state of the resource for creation.
     */
    initTabContent() {
      // A publication advisory service has been selected. Set selection in dropdown.
      if (this.modelValue.publicationServiceRorId) {
        this.selectedService = this.publicationServices.find(
          (s) => s.uri === this.modelValue.publicationServiceRorId,
        );
      }
      // Should there be only one option inside the publication services list, select it
      else if (this.publicationServices.length === 1) {
        this.selectedService = this.publicationServices[0];
        this.selectedServiceText =
          this.publicationServices[0].publicationAdvisoryService?.description ??
          "";
      }

      if (this.modelValue.resourceIds.length > 0) {
        this.selectedResources = this.resources.filter((r) =>
          this.modelValue.resourceIds.some((id) => id === r.id),
        );
      }
    },
    async fetchData() {
      // Load Project Disciplines if not present
      if (this.projectStore.disciplines === null) {
        await this.projectStore.retrieveDisciplines();
      }
      // Load Publication Services if not present
      if (this.projectStore.publicationAdvisoryServices === null) {
        await this.projectStore.retrievePublicationOrganizations(
          this.currentLanguage,
        );
      }
    },
    async retrievePublicationOrganizations(search: string) {
      clearTimeout(this.queryTimer);
      // Replace the list of available organizations
      // with the default one after the search field was cleared
      if (search.trim() === "") {
        // See computed property organizations' definition
        this.projectStore.publicationAdvisoryServices = null;
      }
      // Fetch organizations based on the search query
      else {
        // Add delay to API organization retrieval
        this.queryTimer = window.setTimeout(async () => {
          this.isLoadingPublicationServices = true;
          await this.projectStore.retrievePublicationOrganizations(
            this.currentLanguage,
            search,
          );
          this.isLoadingPublicationServices = false;
        }, 1000);
      }
    },

    updateResourceIds(localResourceIds: string[]) {
      this.$emit("update:resourceIds", localResourceIds);
    },
    updateMessage(localMessage: string | null) {
      this.$emit("update:message", localMessage);
    },
    setResources(resources: ResourceDto[] | null) {
      if (this.resources && resources) {
        const resourceIds: string[] = resources
          .filter((res) => res.id !== undefined)
          .map((res) => res.id as string);

        this.updateResourceIds(resourceIds);
        this.v$.modelValue.resourceIds?.$touch();
      } else if (!resources) {
        this.updateResourceIds([]);
      }
    },

    setMessage(message: string | null) {
      this.updateMessage(message);
      this.v$.modelValue.message.$touch();
    },

    next() {
      this.$emit("next");
    },
  },
});
</script>
